/* user data manipulation -- separated from old 'chanprog' cos it was
   getting way too big */

#include <stdio.h>
#include <string.h>
#include <time.h>
#include "eggdrop.h"
#include "users.h"

extern char botname[];
extern char botuser[];
extern char bothost[];
extern int serv;
extern char curchan[];
extern struct dcc_t dcc[];
extern int dcc_total;
extern int noshare;
extern int nosave;
extern struct userrec *userlist;
extern char cx_file[];
extern int cx_line;
extern int perm_bans;

/* where the user records are stored */
char userfile[121]="";
/* save periodically or whenever there's a change? */
int periodic_save=0;
/* how many minutes will bans last? */
int ban_time=60;
/* how many minutes will ignores last? */
int ignore_time=10;

struct userrec *get_user_by_handle();
struct userrec *get_user_by_host();
struct userrec *get_user_by_handle2();
struct queue *del_q();
struct queue *add_q();

/* ignores are stored as 'hostmask:timer' */
int match_ignore(user)
char *user;
{
  struct userrec *u; struct queue *q; char hst[121],s[161];
  u=get_user_by_handle(IGNORE_NAME);
  if (u==NULL) return 0;
  q=u->host; while (q!=NULL) {
    strcpy(s,q->item); splitc(hst,s,':');
    if (wild_match(hst,user)) return 1;
    q=q->next;
  }
  return 0;
}

int equals_ban(user)
char *user;
{
  struct userrec *u; struct queue *q; char hst[121],s[256];
  u=get_user_by_handle(BAN_NAME);
  if (u==NULL) return 0;
  q=u->host; while (q!=NULL) {
    strcpy(s,q->item); splitc(hst,s,':');
    if (!hst[0]) strcpy(hst,s);
    if (strcasecmp(hst,user)==0) return 1;
    q=q->next;
  }
  return 0;   /* not equal */
}

int match_ban(user)
char *user;
{
  struct userrec *u; struct queue *q; char hst[121],s[256];
  u=get_user_by_handle(BAN_NAME);
  if (u==NULL) return 0;
  q=u->host; while (q!=NULL) {
    strcpy(s,q->item); splitc(hst,s,':');
    if (!hst[0]) strcpy(hst,s);
    if (wild_match(hst,user)) return 1;
    q=q->next;
  }
  return 0;
}

/* if any bans match this wildcard expression, refresh them on the channel */
void refresh_ban(user)
char *user;
{
  struct userrec *u; struct queue *q; char hst[121],s[256];
  u=get_user_by_handle(BAN_NAME);
  if (u==NULL) return;
  q=u->host; while (q!=NULL) {
    strcpy(s,q->item); splitc(hst,s,':');
    if (!hst[0]) strcpy(hst,s);
    if (wild_match(hst,user)) add_mode('+','b',hst);
    q=q->next;
  }
}

int unprog_ban(who)
char *who;
{
  struct userrec *u; int i,j; struct queue *q; char s[256],hst[121];
  context;
  u=get_user_by_handle(BAN_NAME); i=0;
  if (u==NULL) return 0;
  if (atoi(who)) {
    j=atoi(who)-1; q=u->host;
    while ((j>0) && (q!=NULL)) {
      if (q!=NULL) q=q->next;
      j--;
    }
    if (q!=NULL) {
      strcpy(s,q->item); splitc(who,s,':');
      if (!who[0]) strcpy(who,s);
      u->host=del_q(q->item,u->host,&i);
    }
    else return j-atoi(who);
  }
  else {
    /* find matching host, if there is one */
    q=u->host; while ((q!=NULL) && (!i)) {
      strcpy(s,q->item); splitc(hst,s,':');
      if (!hst[0]) strcpy(hst,s);
      if (strcasecmp(who,hst)==0) u->host=del_q(q->item,u->host,&i);
      q=q->next;
    }
  }
  if (i) {
    if (!nosave) {
      if (u->host!=NULL) save_user(u);
      else deluser(BAN_NAME);
    }
    if (!noshare) shareout("-ban %s\n",who);
  }
  return i;
}

int unprog_ignore(who)
char *who;
{
  struct userrec *u; int i,j; struct queue *q; char s[161],hst[121];
  context;
  u=get_user_by_handle(IGNORE_NAME); i=0;
  if (u==NULL) return 0;
  if (atoi(who)) {
    j=atoi(who)-1; q=u->host; 
    while (j>0) {
      if (q!=NULL) q=q->next;
      j--;
    }
    if (q!=NULL) {
      strcpy(s,q->item); splitc(who,s,':');
      u->host=del_q(q->item,u->host,&i);
    }
  }
  else {
    /* find the matching host, if there is one */
    context;
    q=u->host; while ((q!=NULL) && (!i)) {
      context;
      strcpy(s,q->item); splitc(hst,s,':'); context;
      if (strcasecmp(who,hst)==0) u->host=del_q(q->item,u->host,&i);
      q=q->next;
    }
  }
  if (i) {
    context;
    if (!nosave) {
      if (u->host != NULL) save_user(u);
      else deluser(IGNORE_NAME);
    }
    context;
    if (!noshare) shareout("-ignore %s\n",who);
  }
  return i;
}

void prog_ban(who,t,note)
char *who,*note; time_t t;
{
  struct userrec *u; char s[256],*p,oldnote[121]; time_t now=time(NULL);
  context;
  sprintf(s,"%s!%s@%s",botname,botuser,bothost);
  if (wild_match(who,s)) {
    log(LOG_MISC,"Wanted to ban myself: deflected.");
    return;
  }
  if (equals_ban(who)) unprog_ban(who);  /* remove old ban */
  u=get_user_by_handle(BAN_NAME);
  sprintf(s,"%s:%lu",who,t);
  if (note[0]) {
    strcpy(oldnote,note);
    /* remove spaces & commas */
    p=strchr(note,' '); while (p!=NULL) { *p='~'; p=strchr(note,' '); }
    p=strchr(note,','); while (p!=NULL) { *p='`'; p=strchr(note,','); }
    strcat(s,":"); strcat(s,note);
  }
  if (t!=0) { t=(now-t); if (t==now) t=1; }
  if (u==NULL) {
    adduser(BAN_NAME,s,"nopass",USER_BAN);
    if (!noshare) shareout("+ban %s %lu %s\n",who,t,oldnote);
    return;
  }
  u->host=add_q(s,u->host);
  if (!nosave) save_user(u);
  if (!noshare) shareout("+ban %s %lu %s\n",who,t,oldnote);
}

void prog_ignore(who,t)
char *who; time_t t;
{
  struct userrec *u; char s[161]; time_t now=time(NULL);
  context;
  u=get_user_by_handle(IGNORE_NAME);
  sprintf(s,"%s:%lu",who,t);
  if (u==NULL) {
    adduser(IGNORE_NAME,s,"nopass",USER_IGNORE);
    if (!noshare) shareout("+ignore %s %lu\n",who,now-t);
    return;
  }
  u->host=add_q(s,u->host);
  if (!nosave) save_user(u);
  if (!noshare) shareout("+ignore %s %lu\n",who,now-t);
}

void tell_bans(z)
{
  struct userrec *u; struct queue *q; int i,j,k=1; time_t tt,ti;
  char s[256],hst[121],note[41],*p;
  tprintf(z,"Channel bans:   (! = not on channel, * = not placed by bot)\n");
  u=get_user_by_handle(BAN_NAME); tt=time(NULL);
  if (u!=NULL) {
    q=u->host; while (q!=NULL) {
      strcpy(s,q->item); splitc(hst,s,':'); note[0]=0;
      if (!hst[0]) { strcpy(hst,s); ti=0L; } 
      else {
	splitc(note,s,':');
	if (note[0]) { ti=atoi(note); strcpy(note,s); }
	else ti=atol(s);
      }
      if (ti==0) strcpy(s,"(perm)");
      else {
	i=tt-ti; j=(i/60); i=i%60; s[0]=0;
	sprintf(s,"(active %d:%02d)",j,i);
      }
      if (note[0]) {
	/* fix spaces & commas */
	p=strchr(note,'~'); while (p!=NULL) { *p=' '; p=strchr(note,'~'); }
	p=strchr(note,'`'); while (p!=NULL) { *p=','; p=strchr(note,'`'); }
	sprintf(&s[strlen(s)]," (%s)",note);
      }
      if (isbanned(hst))
	tprintf(z,"  [%2d] %s %s\n",k++,hst,s);
      else
	tprintf(z,"! [%2d] %s %s\n",k++,hst,s);
      q=q->next;
    }
  }
  tell_chanbans(z,k);
}

/* list the ignores and how long they've been active */
void tell_ignores(z)
{
  struct userrec *u; struct queue *q; int i,j,k=1; time_t tt,ti;
  char s[161],hst[121];
  u=get_user_by_handle(IGNORE_NAME); tt=time(NULL);
  if (u==NULL) {
    tprintf(z,"No ignores.\n");
    return;
  }
  q=u->host;
  if (q==NULL) tprintf(z,"No ignores.\n");
  while (q!=NULL) {
    strcpy(s,q->item); splitc(hst,s,':'); ti=atol(s);
    if (ti==0) strcpy(s,"(perm)");
    else {
      i=tt-ti; j=(i/60); i=i%60; s[0]=0;
      sprintf(s,"(active %d:%02d)",j,i);
    }
    tprintf(z,"Ignore[%2d]: %s %s\n",k++,hst,s);
    q=q->next;
  }
}

/* check for expired timed-ignores */
void check_expired_ignores()
{
  struct userrec *u; struct queue *q; char s[161],hst[121]; time_t tt,ti;
  int i; context;
  u=get_user_by_handle(IGNORE_NAME); tt=time(NULL);
  if (u==NULL) return;
  q=u->host; if (q==NULL) return;
  while (q!=NULL) {
    strcpy(s,q->item); splitc(hst,s,':'); ti=atol(s);
    if (ti!=0L) if (tt-ti >= 60*ignore_time) {
      /* expired */
      log(LOG_MISC,"No longer ignoring %s (automatically expired)",hst);
      unprog_ignore(hst); u=get_user_by_handle(IGNORE_NAME);
      if (u!=NULL) q=u->host;  /* start over, check for more */
    }
    if (u!=NULL) q=q->next; else q=NULL;
  }
}

/* check for expired timed-bans */
void check_expired_bans()
{
  struct userrec *u; struct queue *q; char s[256],hst[121]; time_t tt,ti;
  int i; char note[41]; context;
  u=get_user_by_handle(BAN_NAME); tt=time(NULL); if (u==NULL) return;
  q=u->host; if (q==NULL) return;
  while (q!=NULL) {
    strcpy(s,q->item); splitc(hst,s,':');
    if (!hst[0]) { strcpy(hst,s); ti=0L; } 
    else {
      splitc(note,s,':'); 
      if (note[0]) ti=atoi(note); else ti=atol(s);
    }
    if (ti!=0L) if (tt-ti >= 60*ban_time) {
      /* expired: 1 hr later */
      log(LOG_MISC,"No longer banning %s (automatically expired)",hst);
      add_mode('-','b',hst);
      unprog_ban(hst); u=get_user_by_handle(BAN_NAME);
      if (u!=NULL) q=u->host;  /* start over, check for more */
    }
    if (u!=NULL) q=q->next; else q=NULL;
  }
}

/* see if there are any bots that need to be linked */
void auto_link_tandem(start)
char *start;
{
  struct userrec *u=userlist,*autc=NULL; int i,j,ok=0;
  context;
  if (start==NULL) ok=1;
  while (u!=NULL) {
    if (((u->flags&USER_TANDEM) && (u->flags&BOT_AUTO))) {
      j=0;
      for (i=0; i<dcc_total; i++)
	if (strcasecmp(dcc[i].nick,u->handle)==0) {
	  if (dcc[i].type==DCC_TANDEM) j=1;
	  if (dcc[i].type==DCC_TANDEM_NEW) j=1;
	  if (dcc[i].type==DCC_FORK) if (dcc[i].u.fork->type==DCC_TANDEM) j=1;
	}
      if (in_chain(u->handle)) j=1;
      if ((!j) && (ok)) {
	if (autc==NULL) autc=u;
	else if (u->flags&BOT_SHARE) autc=u;  /* sharing bots get priority */
      }
      if (!ok) if (strcasecmp(u->handle,start)==0) ok=1;
    }
    if ((u->flags&USER_TANDEM) && (u->flags&BOT_REJECT))
      if (in_chain(u->handle)) {
	/* get rid of nasty reject bot */
	reject_bot(u->handle);
      }
    u=u->next;
  }
  if (autc!=NULL) tandem_link(-1,autc->handle);   /* try autoconnect */
}

/* erase old user list, switch to new one */
void use_new_buf(idx)
int idx;
{
  clear_userlist();
  userlist=dcc[idx].u.tand->user;
  dcc[idx].u.tand->user=NULL;
}

void store_new_user(idx,s)
int idx; char *s;
{
  int i,f=0; char handle[20],host[121],pass[20];
  split(handle,s); split(host,s); split(pass,s);
  strcpy(dcc[idx].host,handle);
  f=str2flags(s);
  nosave=1;
  dcc[idx].u.tand->user=(void *)
    adduser2((struct userrec *)dcc[idx].u.tand->user,handle,host,pass,f);
  nosave=0;
}

void send_tandem_user(z,u)
int z; struct userrec *u;
{
  char f[20]; struct queue *q; char h[121];
  context;
  flags2str(u->flags,f);
  if (u->host==NULL) strcpy(h,"none"); else strcpy(h,u->host->item);
  tprintf(z,"user %s %s %s %s\n",u->handle,h,u->pass,f);
  tprintf(z,"laston %lu\n",u->laston);
  q=u->host->next; while (q!=NULL) {
    tprintf(z,"host %s\n",q->item); q=q->next;
  }
  if (u->email!=NULL) tprintf(z,"email %s\n",u->email);
  if (u->dccdir!=NULL) tprintf(z,"dccdir %s\n",u->dccdir);
  if (u->comment!=NULL) tprintf(z,"comment %s\n",u->comment);
  if (u->info!=NULL) tprintf(z,"info %s\n",u->info);
  tprintf(z,"*user\n");
}

/* begin the user transfer process */
void start_sending_users(z,idx)
{
  struct userrec *u=userlist;
  context;
  if (u==NULL) { tprintf(z,"*userlist"); return; }
  dcc[idx].u.tand->user=(void *)dup_userlist();
  dcc[idx].u.tand->status|=STAT_SENDING;
  u=(struct userrec *)dcc[idx].u.tand->user;
  send_tandem_user(z,u);
}

/* resend user in case of error */
void resend_user(z,idx)
{
  struct userrec *u;
  u=(struct userrec *)dcc[idx].u.tand->user;
  send_tandem_user(z,u);
}

/* send next user (return 1 if end of list) */
int send_next_user(z,idx)
{
  struct userrec *u,*u1;
  context;
  u=(struct userrec *)dcc[idx].u.tand->user;
  if (u==NULL) { 
    tprintf(z,"*userlist\n");
    dcc[idx].u.tand->status&=~STAT_SENDING; return 1;
  }
  u1=u; u=u->next; freeuser(u1); if (u==NULL) {
    tprintf(z,"*userlist\n"); dcc[idx].u.tand->user=NULL;
    dcc[idx].u.tand->status&=~STAT_SENDING; return 1;
  }
  dcc[idx].u.tand->user=(void *)u;
  send_tandem_user(z,u);
  return 0;
}

char *cursend(idx)
int idx;
{
  static char s[81]; struct userrec *u;
  u=(struct userrec *)dcc[idx].u.tand->user;
  if (u!=NULL) strcpy(s,u->handle);
  else strcpy(s,"[EOF]");
  return s;
}

/* update a user's last signon, by host */
void update_laston(host)
char *host;
{
  struct userrec *u;
  u=get_user_by_host(host);
  if (u==NULL) return;
  u->laston=time(NULL);
  if (!nosave) save_user(u);
}

/* return laston time */
void get_handle_laston(nick,n)
char *nick; time_t *n;
{
  struct userrec *u;
  u=get_user_by_handle(nick);
  if (u==NULL) *n=0L;
  else *n = u->laston;
}

void set_handle_laston(nick,n)
char *nick; time_t n;
{
  struct userrec *u;
  u=get_user_by_handle(nick);
  if (u==NULL) return;
  u->laston=n;
  if (!nosave) save_user(u);
}

void set_handle_laston2(bu,nick,n)
struct userrec *bu; char *nick; time_t n;
{
  struct userrec *u;
  u=get_user_by_handle2(bu,nick);
  if (u==NULL) return;
  u->laston=n;
}

void touch_user(nick,n)
char *nick; time_t n;
{
  struct userrec *u;
  u=get_user_by_handle(nick);
  if (u==NULL) return;
  u->laston=n;
  if (!nosave) save_user(u);
}

/* since i was getting a ban list, i assume i'm chop */
/* recheck_bans makes sure that all who are 'banned' on the userlist are
   actually in fact banned on the channel */
void recheck_bans()
{
  struct userrec *u=userlist; struct queue *q; char s[256],hst[121];
  context;
  if (!perm_bans) return;
  u=get_user_by_handle(BAN_NAME);
  if (u==NULL) return;
  q=u->host; while (q!=NULL) {
    strcpy(s,q->item); splitc(hst,s,':');
    if (!hst[0]) strcpy(hst,s);
    if (!isbanned(hst)) add_mode('+','b',hst);
    q=q->next;
  }
}

void tell_user(z,u,master)
int z; struct userrec *u; int master;
{
  char s[81],s1[81],host[81]; struct queue *q; time_t now;
  flags2str(u->flags,s);
  if (u->laston == 0L) strcpy(s1,"never");
  else {
    now=time(NULL)-(u->laston); strcpy(s1,ctime(&(u->laston)));
    if (now>86400) { s1[7]=0; strcpy(&s1[11],&s1[4]); strcpy(s1,&s1[8]); }
    else { s1[16]=0; strcpy(s1,&s1[11]); }
  }
  strcpy(host,u->host->item);
  if (strlen(host)>38) { strcpy(host,"(see below)"); q=u->host; }
  else q=u->host->next;
  tprintf(z,"%-10s%-40s%-10s%-10s%s\n",u->handle,host,(strcasecmp(u->pass,
	  "nopass")==0)?"(no)":"(yes)",s,s1);
  s[0]=0; while (q!=NULL) {
    if (!s[0]) sprintf(s,"          %s",q->item);
    else {
      if (strlen(s)+strlen(q->item)+2>70) {
	tprintf(z,"%s\n",s);
	sprintf(s,"          %s",q->item);
      }
      else {
	strcat(s,", "); strcat(s,q->item);
      }
    }
    q=q->next;
  }
  if (s[0]) tprintf(z,"%s\n",s);
  if ((master) && (u->comment!=NULL))
    tprintf(z,"          COMMENT: %s\n",u->comment);
  if (u->email!=NULL) tprintf(z,"          EMAIL: %s\n",u->email);
  if (u->flags&USER_TANDEM) {
    if (u->info!=NULL) tprintf(z,"          ADDRESS: %s\n",u->info);
  }
  else {
    if (u->info!=NULL) tprintf(z,"          INFO: %s\n",u->info);
  }
}

/* show user by ident */
void tell_user_ident(z,id,master)
int z; char *id; int master;
{
  struct userrec *u;
  u=get_user_by_handle(id);
  if (u==NULL) u=get_user_by_host(id);
  if (u==NULL) {
    tprintf(z,"Can't find anyone matching that.\n");
    return;
  }
  tprintf(z,"%-10s%-40s%-10s%-10s%-10s\n","HANDLE","HOSTMASK(S)","PASS",
	  "ATTR","LAST");
  tell_user(z,u,master);
}

/* match string: wildcard to match nickname or hostmasks */
/*               +attr to find all with attr */
void tell_users_match(z,mtch,master)
int z; char *mtch; int master;
{
  struct userrec *u=userlist; int fnd=0,i,cnt; struct queue *q;
  tprintf(z,"*** Matching '%s':\n",mtch); cnt=0;
  tprintf(z,"%-10s%-40s%-10s%-10s%-10s\n","HANDLE","HOSTMASK(S)","PASS",
	  "ATTR","LAST");
  while (u!=NULL) {
    if (mtch[0]=='+') {
      fnd=str2flags(&mtch[1]);
      if ((u->flags&fnd)==fnd) {
	if (cnt<20) tell_user(z,u,master); cnt++;
	if (cnt==21) tprintf(z,"(more than 20 matches; list truncated)\n");
      }
    }
    else if (wild_match(mtch,u->handle)) {
      if (cnt<20) tell_user(z,u,master); cnt++;
      if (cnt==21) tprintf(z,"(more than 20 matches; list truncated)\n");
    }
    else {
      fnd=0; q=u->host; while (q!=NULL) {
	if ((wild_match(mtch,q->item)) && (!fnd)) {
	  if (cnt<20) tell_user(z,u,master); fnd=1; cnt++;
	  if (cnt==21) tprintf(z,"(more than 20 matches; list truncated)\n");
	}
	q=q->next;
      }
    }
    u=u->next;
  }
  tprintf(z,"--- Found %d match%s.\n",cnt,cnt==1?"":"es");
}

int readuserfile(file)
char *file;
{
  char *p,s[121],lasthand[20],host[121],attr[121],pass[121],code[121];
  FILE *f; int flags,i;
  context;
  lasthand[0]=0; f=fopen(file,"r");
  if (f==NULL) return 0;
  nosave=1; noshare=1;
  while (!feof(f)) {
    fgets(s,120,f);
    if (!feof(f)) {
      rmspace(s);
      if ((s[0]!='#') && (s[0]!=';') && (s[0])) {
	nsplit(code,s); rmspace(code); rmspace(s);
	if (strcasecmp(code,"-")==0) {
	  if (lasthand[0]) {
	    p=strchr(s,','); while (p!=NULL) {
	      splitc(code,s,','); rmspace(code); rmspace(s);
	      if (code[0]) addhost_by_handle(lasthand,code);
	      p=strchr(s,',');
	    }
	    if (s[0]) addhost_by_handle(lasthand,s);
	  }
	}
	else if (strcasecmp(code,"+")==0) {
	  if (lasthand[0]) {
	    set_handle_email(lasthand,s);
	  }
	}
	else if (strcasecmp(code,"*")==0) {
	  if (lasthand[0]) {
	    set_handle_dccdir(lasthand,s);
	  }
	}
	else if (strcasecmp(code,"=")==0) {
	  if (lasthand[0]) {
	    set_handle_comment(lasthand,s);
	  }
	}
	else if (strcasecmp(code,":")==0) {
	  if (lasthand[0]) {
	    set_handle_info(lasthand,s);
	  }
	}
	else {
	  nsplit(host,s); rmspace(host); rmspace(s);
	  nsplit(pass,s); rmspace(pass); rmspace(s);
	  nsplit(attr,s); rmspace(attr); rmspace(s);
	  if ((!s[0]) || (!attr[0]) || (!pass[0]) || (!host[0])) {
	    log(LOG_MISC,"* Corrupt user record '%s'!",code);
	    lasthand[0]=0;
	  }
	  else if (is_user(code)) {
	    log(LOG_MISC,"* Duplicate user record '%s'!",code);
	    lasthand[0]=0;
	  }
	  else {
	    flags=str2flags(attr); strcpy(lasthand,code);
	    if (strcasecmp(host,"$placeholder$")==0) host[0]=0;
	    if (strlen(code)>9) code[9]=0;
	    if (strlen(pass)>9) pass[9]=0;
	    adduser(code,host,pass,flags);
	    touch_user(code,atol(s));
	  }
	}
      }
    }
  }
  noshare=0;
  if (!periodic_save) nosave=0; fclose(f); return 1;
}
